import argparse
from datetime import timedelta
import asyncio
from websockets.client import connect
import time 
import random
STANDART_GEOPOSITION = [
    ['56.011419', '92.854252'], 
    ['55.979687', '92.809201'], 
    ['56.081728', '92.939978'], 
    ['56.048852', '92.760782'], 
    ['55.998735', '93.023395'], 
    ['56.013049', '92.873826'], 
    ['56.015042', '92.863971'], 
    ['55.997396', '92.904692'], 
    ['55.990378', '92.891720'], 
    ['56.009195', '92.885234']
]
STANDART_PORT = 9992
STANDART_ADRESS = "localhost"
parser = argparse.ArgumentParser()
parser.add_argument('-f', '--filename', help='какой файл открыть')
parser.add_argument('-t', '--time', help='интервал отпраки', default = 1)
parser.add_argument('-p', '--port',  help='порт', default = STANDART_PORT)
parser.add_argument('-a', '--adress', help='адрес', default = STANDART_ADRESS)
parser.add_argument('-d', '--devices',  help='для установки кол-во устройств', default = 10)
parser.add_argument('-k', '--keys',  help='путь к файлу с ключом')
parser.add_argument('-debug_mode', '--debug_mode', help="режим отладки", default=False)
args = parser.parse_args()
time_flag=1
if args.time:
    time_flag = int(args.time)
    interval_time = timedelta(seconds=time_flag)
if args.port:
    port_flag = str(args.port)
if args.adress:
    address_flag = str(args.adress)
if args.devices:
    count_device = str(args.devices)
if args.keys:
    keys_flag = str(args.keys)
    


async def otpravka(token):
    webdeb = f"ws://{address_flag}:{port_flag}/ws/{token}/sendGeo"
    async with connect(webdeb) as websocket:
        while True:  
            la, lo = random.choice(STANDART_GEOPOSITION)
            t = time.time()
            message = f'{{"la": {la}, "lo": {lo}, "ts": {t}}}'
            await websocket.send(message)
            if args.debug_mode:
                print(f"Отправлено: {message}")
            response = await websocket.recv()
            if args.debug_mode:
                print(f"Received: {response} for token: {token}")
            await asyncio.sleep(time_flag)

async def main():
    # with open('token.txt', 'r') as file:
    #     tokens = [line.strip() for line in file.readlines()]
    if args.filename:
        tokens = []
        b = args.filename 
        try:
            with open(b) as file:  
                tokens = file.readlines()
        except FileNotFoundError:
            print("Файл не найден, использован стандартный набор:", STANDART_GEOPOSITION)
    else:
        print("Не удалось прочесть токены")
        return
    
    if len(tokens) != int(count_device):
        print("Количество токенов не совпадает с количеством устройств")
        return
    tasks = [
        asyncio.create_task(otpravka(tokens[i])) for i in range(int(count_device))
    ]
    await asyncio.gather(*tasks)
asyncio.run(main())


